<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="450px" @confirm="handleSubmit" @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="84px" :rules="formRules">
                <el-form-item label="上级组织" prop="pid" v-if="formData.pid !== 0">
                    <el-tree-select
                        class="flex-1"
                        v-model="formData.pid"
                        :data="optionsData.dept"
                        clearable
                        node-key="id"
                        :props="{
                            value: 'id',
                            label: 'name'
                        }"
                        check-strictly
                        :default-expand-all="true"
                        placeholder="请选择上级组织"
                    />
                </el-form-item>
                <el-form-item label="组织名称" prop="name">
                    <el-input v-model="formData.name" placeholder="请输入组织名称" clearable :maxlength="100" />
                </el-form-item>
                <el-form-item label="组织状态" prop="status">
                    <el-switch v-model="formData.status" :active-value="1" :inactive-value="0" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>
<script lang="ts" setup>
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { useDictOptions } from '@/hooks/useDictOptions'
import feedback from '@/utils/feedback'
import { organzationDetail, organzationEdit, organzationLists, organzationtAdd } from '@/api/account_center/organization'

const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑组织' : '新增组织'
})
const formData = reactive({
    id: '',
    pid: '' as string | number,
    name: '',
    status: 1
})
const formRules = {
    pid: [
        {
            required: true,
            message: '请选择上级组织',
            trigger: ['change']
        }
    ],
    name: [
        {
            required: true,
            message: '请输入组织名称',
            trigger: ['blur']
        }
    ]
}

const { optionsData } = useDictOptions<{
    dept: any[]
}>({
    dept: {
        api: organzationLists
    }
})

const handleSubmit = async () => {
    await formRef.value?.validate()
    mode.value == 'edit' ? await organzationEdit(formData) : await organzationtAdd(formData)
    popupRef.value?.close()
    feedback.msgSuccess('操作成功')
    emit('success')
}

const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

const setFormData = (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
}

const getDetail = async (row: Record<string, any>) => {
    console.log(row)

    const data = await organzationDetail({
        id: row.id
    })
    console.log(data, '==')

    setFormData(data)
}

const handleClose = () => {
    emit('close')
}

defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
